/******/ (() => { // webpackBootstrap
var __webpack_exports__ = {};
navigator.serviceWorker.getRegistrations().then(function (registrations) {
  for (let registration of registrations) {
    registration.unregister();
  }
});

// https://developers.google.com/web/tools/workbox/guides/troubleshoot-and-debug
importScripts('https://storage.googleapis.com/workbox-cdn/releases/5.0.0-beta.1/workbox-sw.js');

// Install newest
// https://developers.google.com/web/tools/workbox/modules/workbox-core
workbox.core.skipWaiting();
workbox.core.clientsClaim();

// Cache static assets that aren't precached
workbox.routing.registerRoute(/\.(?:js|css|json5)$/, new workbox.strategies.StaleWhileRevalidate({
  cacheName: 'static-resources'
}));

// Cache the Google Fonts stylesheets with a stale-while-revalidate strategy.
workbox.routing.registerRoute(/^https:\/\/fonts\.googleapis\.com/, new workbox.strategies.StaleWhileRevalidate({
  cacheName: 'google-fonts-stylesheets'
}));

// Cache the underlying font files with a cache-first strategy for 1 year.
workbox.routing.registerRoute(/^https:\/\/fonts\.gstatic\.com/, new workbox.strategies.CacheFirst({
  cacheName: 'google-fonts-webfonts',
  plugins: [new workbox.cacheableResponse.CacheableResponsePlugin({
    statuses: [0, 200]
  }), new workbox.expiration.ExpirationPlugin({
    maxAgeSeconds: 60 * 60 * 24 * 365,
    // 1 Year
    maxEntries: 30
  })]
}));

// MESSAGE HANDLER
self.addEventListener('message', event => {
  if (event.data && event.data.type === 'SKIP_WAITING') {
    switch (event.data.type) {
      case 'SKIP_WAITING':
        // TODO: We'll eventually want this to be user prompted
        // workbox.core.skipWaiting();
        // workbox.core.clientsClaim();
        // TODO: Global notification to indicate incoming reload
        break;
      default:
        console.warn(`SW: Invalid message type: ${event.data.type}`);
    }
  }
});
workbox.precaching.precacheAndRoute([{'revision':null,'url':'./151.bundle.31ea35044218837bf73f.js'},{'revision':null,'url':'./192.bundle.7d856cb20aba84cf8768.js'},{'revision':null,'url':'./199.bundle.5641e23dd77145e03338.js'},{'revision':null,'url':'./205.bundle.b5a473c200dcf2bbcdb4.js'},{'revision':null,'url':'./208.bundle.9899e039c4ecc93e9e03.js'},{'revision':null,'url':'./270.bundle.4564621556b0f963a004.js'},{'revision':null,'url':'./283.bundle.d8437c88cc514e88a34d.js'},{'revision':null,'url':'./295.bundle.957b1159fec14b9199a1.js'},{'revision':null,'url':'./331.bundle.bd0c13931a21d53086c9.js'},{'revision':null,'url':'./351.bundle.2d4bc19d8b493879dbbe.js'},{'revision':'a04a2f233dc569826f5f6e21b65bc87b','url':'./351.css'},{'revision':'c4ea120c6da08aa75348edfa3e57ece9','url':'./36785fbd89b0e17f6099.wasm'},{'revision':null,'url':'./381.bundle.0905e683605fcbc0895f.js'},{'revision':null,'url':'./404.bundle.2108f848f8046ea1418f.js'},{'revision':null,'url':'./50.bundle.836d0cc313935a7c195a.js'},{'revision':'c377e1f5fe4a207d270c3f7a8dd3e3ca','url':'./5004fdc02f329ce53b69.wasm'},{'revision':null,'url':'./531.bundle.2a82fb1d69e5b57cc72b.js'},{'revision':null,'url':'./55.bundle.5f5e5ef9087b0beee35c.js'},{'revision':'0afb25509c7f072fbd7eda42c6895dbf','url':'./55.css'},{'revision':null,'url':'./569.bundle.0ed8d8178ffd43fe1c34.js'},{'revision':null,'url':'./581.bundle.360d26f97b37da8faec3.js'},{'revision':null,'url':'./606.bundle.5d876f5f3dd8287f0a28.js'},{'revision':'62b4ae8445d191d5aab5503ce475724d','url':'./610.min.worker.js'},{'revision':'3c2206525c18cd87dd28082949a4e43e','url':'./610.min.worker.js.map'},{'revision':null,'url':'./616.bundle.6a8bba390a0bd1e8a74c.js'},{'revision':'5800265b6831396572fb5d32c6bd8eef','url':'./62ab5d58a2bea7b5a1dc.wasm'},{'revision':null,'url':'./642.bundle.01de8ebc3f28ade76fe0.js'},{'revision':'ce10eced3ce34e663d86569b27f5bffb','url':'./65916ef3def695744bda.wasm'},{'revision':null,'url':'./664.bundle.09abae984223969d1bde.js'},{'revision':null,'url':'./707.bundle.f094a10c961fc8e152de.js'},{'revision':'185e5e0a10fa6ab2fc7b3c38e63d550b','url':'./707.css'},{'revision':null,'url':'./728.bundle.d13856835357400fef82.js'},{'revision':null,'url':'./744.bundle.94a8214a295a2b44450d.js'},{'revision':'cf3e4d4fa8884275461c195421812256','url':'./75788f12450d4c5ed494.wasm'},{'revision':'cc4a3a4da4ac1b863a714f93c66c6ef2','url':'./75a0c2dfe07b824c7d21.wasm'},{'revision':null,'url':'./780.bundle.fd0f13dc92e9caa0581e.js'},{'revision':null,'url':'./790.bundle.063f4f1851a7a624d53f.js'},{'revision':null,'url':'./799.bundle.ca18bdf4abe4d9abea26.js'},{'revision':'51b8ed55f5b8d448837222f03bdd6de8','url':'./806.css'},{'revision':null,'url':'./82.bundle.e4f525e07cf2c10d9fc8.js'},{'revision':null,'url':'./917.bundle.b0a513987ccda76b9bac.js'},{'revision':null,'url':'./926.bundle.dbc9d0e591cb9217fda2.js'},{'revision':null,'url':'./935.bundle.deeffff0e4f7b528e3c3.js'},{'revision':'b12abc3008862bb7daf6a91d2a13cf6a','url':'./945.min.worker.js'},{'revision':'3aba0a4898e93871a7cd61b4d0216a18','url':'./945.min.worker.js.map'},{'revision':null,'url':'./953.bundle.9e3a7225f07336bfcb41.js'},{'revision':null,'url':'./973.bundle.7d9109d7a665f3be07cc.js'},{'revision':null,'url':'./976.bundle.f96219ca2059c40cb5d2.js'},{'revision':null,'url':'./984.bundle.8037db02455809293521.js'},{'revision':'d1895aa7a4595dc279c382e5a31ef9f4','url':'./_headers'},{'revision':'6839a719b6810111d8097998b11293a1','url':'./_redirects'},{'revision':'db6fe78a2311f21f5bdbd90ffded7ce4','url':'./app-config.js'},{'revision':'2908f2d43ada30e93d4e58b656b159dc','url':'./app.bundle.css'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'./assets/android-chrome-144x144.png'},{'revision':'5cde390de8a619ebe55a669d2ac3effd','url':'./assets/android-chrome-192x192.png'},{'revision':'e7466a67e90471de05401e53b8fe20be','url':'./assets/android-chrome-256x256.png'},{'revision':'9bbe9b80156e930d19a4e1725aa9ddae','url':'./assets/android-chrome-36x36.png'},{'revision':'5698b2ac0c82fe06d84521fc5482df04','url':'./assets/android-chrome-384x384.png'},{'revision':'56bef3fceec344d9747f8abe9c0bba27','url':'./assets/android-chrome-48x48.png'},{'revision':'3e8b8a01290992e82c242557417b0596','url':'./assets/android-chrome-512x512.png'},{'revision':'517925e91e2ce724432d296b687d25e2','url':'./assets/android-chrome-72x72.png'},{'revision':'4c3289bc690f8519012686888e08da71','url':'./assets/android-chrome-96x96.png'},{'revision':'cf464289183184df09292f581df0fb4f','url':'./assets/apple-touch-icon-1024x1024.png'},{'revision':'0857c5282c594e4900e8b31e3bade912','url':'./assets/apple-touch-icon-114x114.png'},{'revision':'4208f41a28130a67e9392a9dfcee6011','url':'./assets/apple-touch-icon-120x120.png'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'./assets/apple-touch-icon-144x144.png'},{'revision':'977d293982af7e9064ba20806b45cf35','url':'./assets/apple-touch-icon-152x152.png'},{'revision':'6de91b4d2a30600b410758405cb567b4','url':'./assets/apple-touch-icon-167x167.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'./assets/apple-touch-icon-180x180.png'},{'revision':'647386c34e75f1213830ea9a38913525','url':'./assets/apple-touch-icon-57x57.png'},{'revision':'0c200fe83953738b330ea431083e7a86','url':'./assets/apple-touch-icon-60x60.png'},{'revision':'517925e91e2ce724432d296b687d25e2','url':'./assets/apple-touch-icon-72x72.png'},{'revision':'c9989a807bb18633f6dcf254b5b56124','url':'./assets/apple-touch-icon-76x76.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'./assets/apple-touch-icon-precomposed.png'},{'revision':'87bff140e3773bd7479a620501c4aa5c','url':'./assets/apple-touch-icon.png'},{'revision':'05fa74ea9c1c0c3931ba96467999081d','url':'./assets/apple-touch-startup-image-1182x2208.png'},{'revision':'9e2cd03e1e6fd0520eea6846f4278018','url':'./assets/apple-touch-startup-image-1242x2148.png'},{'revision':'5591e3a1822cbc8439b99c1a40d53425','url':'./assets/apple-touch-startup-image-1496x2048.png'},{'revision':'337de578c5ca04bd7d2be19d24d83821','url':'./assets/apple-touch-startup-image-1536x2008.png'},{'revision':'cafb4ab4eafe6ef946bd229a1d88e7de','url':'./assets/apple-touch-startup-image-320x460.png'},{'revision':'d9bb9e558d729eeac5efb8be8d6111cc','url':'./assets/apple-touch-startup-image-640x1096.png'},{'revision':'038b5b02bac8b82444bf9a87602ac216','url':'./assets/apple-touch-startup-image-640x920.png'},{'revision':'2177076eb07b1d64d663d7c03268be00','url':'./assets/apple-touch-startup-image-748x1024.png'},{'revision':'4fc097443815fe92503584c4bd73c630','url':'./assets/apple-touch-startup-image-750x1294.png'},{'revision':'2e29914062dce5c5141ab47eea2fc5d9','url':'./assets/apple-touch-startup-image-768x1004.png'},{'revision':'f692ec286b3a332c17985f4ed38b1076','url':'./assets/browserconfig.xml'},{'revision':'f3d9a3b647853c45b0e132e4acd0cc4a','url':'./assets/coast-228x228.png'},{'revision':'ad6e1def5c66193d649a31474bbfe45d','url':'./assets/favicon-16x16.png'},{'revision':'84d1dcdb6cdfa55e2f46be0c80fa5698','url':'./assets/favicon-32x32.png'},{'revision':'95fb44c4998a46109e49d724c060db24','url':'./assets/favicon.ico'},{'revision':'5df2a5b0cee399ac0bc40af74ba3c2cb','url':'./assets/firefox_app_128x128.png'},{'revision':'11fd9098c4b07c8a07e1d2a1e309e046','url':'./assets/firefox_app_512x512.png'},{'revision':'27cddfc922dca3bfa27b4a00fc2f5e36','url':'./assets/firefox_app_60x60.png'},{'revision':'2017d95fae79dcf34b5a5b52586d4763','url':'./assets/manifest.webapp'},{'revision':'cb4f64534cdf8dd88f1d7219d44490db','url':'./assets/mstile-144x144.png'},{'revision':'334895225e16a7777e45d81964725a97','url':'./assets/mstile-150x150.png'},{'revision':'e295cca4af6ed0365cf7b014d91b0e9d','url':'./assets/mstile-310x150.png'},{'revision':'cbefa8c42250e5f2443819fe2c69d91e','url':'./assets/mstile-310x310.png'},{'revision':'aa411a69df2b33a1362fa38d1257fa9d','url':'./assets/mstile-70x70.png'},{'revision':'5609af4f69e40e33471aee770ea1d802','url':'./assets/yandex-browser-50x50.png'},{'revision':'cfea70d7ddc8f06f276ea0c85c4b2adf','url':'./assets/yandex-browser-manifest.json'},{'revision':'52b9a07fe0541fe8c313d9788550bf51','url':'./b6b803111e2d06a825bd.wasm'},{'revision':'7edb59d2be7c993050cb31ded36afa31','url':'./c22b37c3488e1d6c3aa4.wasm'},{'revision':'977e85178e03b1fe29ae11396e8d3103','url':'./cornerstoneDICOMImageLoader.min.js'},{'revision':'9a040594269dd626f02f8186e3a3f31b','url':'./cornerstoneDICOMImageLoader.min.js.map'},{'revision':null,'url':'./dicom-microscopy-viewer.bundle.aa60bdf008c32c39cfd7.js'},{'revision':'9d8c85b42d04bb117a3b583d654fbb08','url':'./dicomMicroscopyViewer.min.js'},{'revision':'450494c199cf8dd8e8c34d5e98bf5334','url':'./dicomMicroscopyViewer.min.js.LICENSE.txt'},{'revision':'0ca44a1b8719e835645ffa804a9d1395','url':'./es6-shim.min.js'},{'revision':'c120b64a5930bc240d1d6bf358ac3907','url':'./google.js'},{'revision':'4b43859249f53c7b0c1bbc9e87876896','url':'./index.html'},{'revision':'f16a354af72a2bc85ce7e7caf5786ecd','url':'./index.worker.ea71efba2ce63c499055.worker.js'},{'revision':'806287e806015aedcb007866ca308151','url':'./index.worker.ea71efba2ce63c499055.worker.js.map'},{'revision':'71cec55513e051f0778ad89be760c11a','url':'./index.worker.min.worker.js'},{'revision':'fd1116add443fee52a935df926396e0f','url':'./index.worker.min.worker.js.map'},{'revision':'c4c4be134438c4cc55613210f3913526','url':'./init-service-worker.js'},{'revision':'74fc9658b62903be2048c1f82a22b4d4','url':'./manifest.json'},{'revision':'3fa71aa0af3e34b4ebd9a71eee0f4bdd','url':'./ohif-logo-light.svg'},{'revision':'7e81da785c63e75650101db6c5d7560e','url':'./ohif-logo.svg'},{'revision':'754d698a7b334af57c00f29723fd9751','url':'./oidc-client.min.js'},{'revision':'d05a380d50b74e629738ae6f62fb7e78','url':'./polyfill.min.js'},{'revision':'f528b6861c82ee4415fce0821fd695c1','url':'./silent-refresh.html'}]);

// TODO: Cache API
// https://developers.google.com/web/fundamentals/instant-and-offline/web-storage/cache-api
// Store DICOMs?
// Clear Service Worker cache?
// navigator.storage.estimate().then(est => console.log(est)); (2GB?)
/******/ })()
;